## ball 1.5.0+git20180813.37fc53c

=== CMakeLists.txt ===
########################################################
#
# CMake configuration for BALL
# http://www.ball-project.org
#
########################################################

CMAKE_MINIMUM_REQUIRED(VERSION 3.1.0 FATAL_ERROR)

CMAKE_POLICY(SET CMP0042 OLD)
CMAKE_POLICY(SET CMP0043 NEW)
CMAKE_POLICY(SET CMP0048 NEW)

IF(POLICY CMP0071)
	CMAKE_POLICY(SET CMP0071 NEW)
ENDIF()


PROJECT("BALL" VERSION 1.5.0)


########################################################
# General build system settings
########################################################

# Use folders to group TARGTES using the folder target property in IDEs
SET(USE_FOLDERS TRUE)

# Automatically search lib64 folders
SET(FIND_LIBRARY_USE_LIB64_PATHS TRUE)

# Set default build type to Release
IF(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE Release)
ENDIF()

# Add cmake directory from BALL source tree to CMAKE_MODULE_PATH
SET(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${PROJECT_SOURCE_DIR}/cmake")

# Add include directoy from BALL source tree
INCLUDE_DIRECTORIES("${PROJECT_SOURCE_DIR}/include")

# Add include directoy from build tree for configured files
INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}/include")

# Handling user specified path to ball_contrib installation (-DBALL_CONTRIB_PATH)
# TODO: Get rid of BALL_CONTRIB_PATH when globally refactoring build system
SET(BALL_CONTRIB_PATH "" CACHE PATH "Path to the ball_contrib installation directory (optional)")
IF(BALL_CONTRIB_PATH)
	# Add include directoy from user specified BALL_CONTRIB_PATH
	INCLUDE_DIRECTORIES("${BALL_CONTRIB_PATH}/include")

	# Add ball contrib install directories to CMake search paths for find_XXX() functions
	SET(CMAKE_PREFIX_PATH  "${BALL_CONTRIB_PATH}" "${CMAKE_PREFIX_PATH}")

	# Required for CMake include and compile tests (seems to be required only on Windows)
	SET(CMAKE_REQUIRED_INCLUDES ${BALL_CONTRIB_PATH}/include ${CMAKE_REQUIRED_INCLUDES})
ENDIF()

# Include BALL specific CMake macros
INCLUDE(cmake/BALLMacros.cmake)

# BALL specific compiler and linker settings
SET(BALL_PROJECT_COMPILE_FLAGS "")
SET(BALL_PROJECT_COMPILE_DEFNS "")
INCLUDE(BALLCompilerSpecific)

# Determine BALL configuration
INCLUDE(BALLConfiguration)

INCLUDE(GNUInstallDirs)

# We do not have a Component-based installer in MacOS
IF(NOT APPLE)
	INCLUDE(BALLComponents)
ENDIF()

# License choice: LGPL or GPL build
SET(BALL_LICENSE "LGPL" CACHE STRING "BALL licensing model: LGPL (default) or GPL")

IF(${BALL_LICENSE} STREQUAL "LGPL")
	SET(BALL_LICENSE_LGPL TRUE)
	SET(BALL_LICENSE_GPL  FALSE)
ELSEIF(${BALL_LICENSE} STREQUAL "GPL")
	SET(BALL_LICENSE_LGPL FALSE)
	SET(BALL_LICENSE_GPL  TRUE)
ELSE()
	MESSAGE(FATAL_ERROR "BALL_LICENSE can either be 'LGPL' (default) or 'GPL'")
ENDIF()



########################################################
# Search and configure third party dependencies
########################################################

## Extra libraries we want to link into BALL
SET(BALL_DEP_LIBRARIES)
SET(VIEW_DEP_LIBRARIES)

## Flex and Bison
## This ugly hack is required as long as we cannot tell cmake to set an environment variable for bison...
IF (WIN32)
	FIND_PROGRAM(BISON_EXECUTABLE BALL-bison.bat DOC "path to the bison executable")
ENDIF()
FIND_PACKAGE(BISON)
IF (NOT BISON_FOUND)
	MESSAGE(FATAL_ERROR "Could not find bison parser generator!")
ENDIF()

IF (WIN32)
	SET(BALL_BISON_BAT ${BISON_EXECUTABLE})
	SET(BISON_EXECUTABLE "call")
ENDIF()

FIND_PACKAGE(FLEX)
IF (NOT FLEX_FOUND)
	MESSAGE(FATAL_ERROR "Could not find flex scanner generator!")
ENDIF()
## Figure out if the used flex version supports ...lex_destroy()
MESSAGE(STATUS "Checking for yylex_destroy support in flex")
STRING(REGEX REPLACE "^([0-9]+)\\.([0-9]+)\\.([0-9]+).*$" "\\1;\\2;\\3"
	FLEX_VERSION_NUMERIC ${FLEX_VERSION})
LIST(GET FLEX_VERSION_NUMERIC 2 FLEX_PATCH_LEVEL)
IF (FLEX_PATCH_LEVEL GREATER 8)
	MESSAGE(STATUS "Checking for yylex_destroy support in flex - found")
	SET(BALL_HAS_YYLEX_DESTROY TRUE)
ELSE()
	MESSAGE(STATUS "Checking for yylex_destroy support in flex - Not found")
	SET(BALL_HAS_YYLEX_DESTROY FALSE)
ENDIF()


## XDR related stuff
INCLUDE(BALLConfigXDR)

## Boost and Asio
INCLUDE(BALLConfigBoost)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
LIST(APPEND BALL_DEP_LIBRARIES ${Boost_LIBRARIES})



# OpenBabel availability: default false
SET(BALL_HAS_OPENBABEL FALSE)

IF(${BALL_LICENSE_GPL})

	# FFTW
	OPTION(USE_FFTWD "Use double precision FFTW if found" ON)
	OPTION(USE_FFTWF "Use single precision FFTW if found" ON)
	OPTION(USE_FFTWF "Use long double precision FFTW if found" ON)
	OPTION(USE_FFTW_THREADS "Try to find FFTW with thread support" OFF)

	FIND_PACKAGE(FFTW)
	IF(FFTW_FOUND)
		INCLUDE_DIRECTORIES(${FFTW_INCLUDE_DIR})
		INCLUDE(BALLConfigFFTW)
	ENDIF()

	#Set the default complex precision to float if the setting for this value
	#could not be determined earlier
	IF(NOT BALL_COMPLEX_PRECISION)
		SET(BALL_COMPLEX_PRECISION "float")
	ENDIF()


	# OpenBabel
	FIND_PACKAGE(OpenBabel2)
	IF(OPENBABEL2_FOUND)
		SET(BALL_HAS_OPENBABEL TRUE)
		INCLUDE_DIRECTORIES(${OPENBABEL2_INCLUDE_DIRS})
		LIST(APPEND BALL_DEP_LIBRARIES ${OPENBABEL2_LIBRARIES})
	ELSE()
		MESSAGE("Could not find a OpenBabel2 installation. Skipping OpenBabel dependencies.")
	ENDIF()

ENDIF()


## lpsolve
OPTION(USE_LPSOLVE "Compile with lpsolve support, if lpsolve can be found" ON)

FIND_PACKAGE(LPSolve)
IF (LPSOLVE_FOUND)
	SET(BALL_HAS_LPSOLVE TRUE)
	INCLUDE_DIRECTORIES(${LPSOLVE_INCLUDE_DIR})
ENDIF()

## libsvm
OPTION(USE_LIBSVM "Compile with libsvm support if libsvm can be found" ON)

IF(USE_LIBSVM)
	FIND_PACKAGE(libSVM)
	IF (LIBSVM_FOUND)
		SET(BALL_HAS_LIBSVM TRUE)
		INCLUDE_DIRECTORIES(${LIBSVM_INCLUDE_DIRS})
	ENDIF()
ENDIF()

## CUDA
SET(USE_CUDA OFF CACHE BOOL "Should CUDA support be enabled (version <= 2.1 currently supported)?")

IF(USE_CUDA)
	FIND_PACKAGE(CUDA REQUIRED)
ENDIF()

## TBB
SET(USE_TBB ON CACHE BOOL "Should Intel Threading Building Blocks support be enabled?")
SET(REQUIRE_TBB OFF CACHE BOOL "Should Intel Threading Building Blocks support be required?")

## RTFact would require tbb... so check if it is required
IF(REQUIRE_RTFACT)
	SET(REQUIRE_TBB ON)
ENDIF()

IF(USE_TBB)
	IF (REQUIRE_TBB)
		FIND_PACKAGE(TBB REQUIRED)
	ELSE()
		FIND_PACKAGE(TBB)
		IF (NOT TBB_FOUND)
			MESSAGE(STATUS "Intel Threading Building Blocks not found!")
		ENDIF()
	ENDIF()

	IF(${BALL_LICENSE_GPL} OR NOT ${TBB_VERSION_MAJOR} VERSION_LESS 2017)

		IF (TBB_FOUND)
			INCLUDE_DIRECTORIES(${TBB_INCLUDE_DIRS})
			BALL_COMBINE_LIBS(TBB_LIBRARIES "${TBB_LIBRARIES}" "${TBB_DEBUG_LIBRARIES}")
			LIST(REMOVE_DUPLICATES TBB_LIBRARIES)

			SET(BALL_HAS_TBB TRUE)
		ENDIF()

	ENDIF()

ENDIF()

## MPI
OPTION(USE_MPI "Should MPI support be enabled?" ON)
OPTION(REQUIRE_MPI "Should MPI support be required?" OFF)

IF (USE_MPI)
	IF (REQUIRE_MPI)
		FIND_PACKAGE(MPI REQUIRED)
	ELSE()
		FIND_PACKAGE(MPI)
	ENDIF()

	IF (MPI_FOUND)
		SET(BALL_PROJECT_COMPILE_FLAGS "${BALL_PROJECT_COMPILE_FLAGS} ${MPI_CXX_COMPILE_FLAGS}")
		INCLUDE_DIRECTORIES(${MPI_CXX_INCLUDE_PATH})

		SET(BALL_HAS_MPI TRUE)
	ENDIF()

ENDIF()

## VIEW related options/settings/libraries
SET(UPDATE_TRANSLATIONS OFF CACHE BOOL "If enabled, translations are update")
OPTION(BALL_HAS_VIEW "Compile BALL's VIEW library required for visualization and graphical user interfaces" ON)

## QT
OPTION(USE_QTWEBENGINE "Add support for QtWebEngine" ON)

# Enable automatic invocation of moc if required
SET(CMAKE_AUTOMOC ON)
SET(CMAKE_AUTOMOC_MOC_OPTIONS "-DBALL_DEPRECATED=") # Fix issues on some machines where moc would ignore classes with
                                                    # multiple attribute specifications via global macros

SET(QTDIR "" CACHE PATH "Path to the qt installation (optional)")
SET(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${QTDIR})

IF(QTDIR)
	INCLUDE_DIRECTORIES(BEFORE "${QTDIR}/include")
ENDIF()

SET(QT_MIN_VERSION 5.5)

FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} REQUIRED Core Network Xml)

LIST(APPEND BALL_DEP_LIBRARIES Qt5::Core
                               Qt5::Network
                               Qt5::Xml)
LIST(APPEND BALL_PROJECT_COMPILE_DEFNS "-DQT_NO_KEYWORDS")

IF (BALL_HAS_VIEW)
	FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} REQUIRED OpenGL PrintSupport Test Widgets)
	FIND_PACKAGE(Qt5LinguistTools ${QT_MIN_VERSION})

	IF(NOT Qt5LinguistTools_FOUND)
		MESSAGE(WARNING "Qt5LinguistTools not found: BALLView translations cannot be created and compiled.")
	ENDIF()

	LIST(APPEND VIEW_DEP_LIBRARIES Qt5::OpenGL
	                               Qt5::PrintSupport
	                               Qt5::Test
	                               Qt5::Widgets)

	# WebEngine support
	IF(USE_QTWEBENGINE)
		FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} QUIET COMPONENTS WebEngine WebEngineWidgets WebChannel)

		SET(BALL_HAS_QTWEBENGINE TRUE)
		IF(NOT Qt5WebEngine_FOUND)
			MESSAGE(STATUS "QtWebEngine has not been found. Disabling WebEngine support.")
			SET(BALL_HAS_QTWEBENGINE FALSE)
		ENDIF()

		IF(NOT Qt5WebEngineWidgets_FOUND)
			MESSAGE(STATUS "QtWebEngineWidgets has not been found. Disabling WebEngine support.")
			SET(BALL_HAS_QTWEBENGINE FALSE)
		ENDIF()

		IF(NOT Qt5WebChannel_FOUND)
			MESSAGE(STATUS "QtWebChannel has not been found. Disabling WebEngine support.")
			SET(BALL_HAS_QTWEBENGINE FALSE)
		ENDIF()

		IF(BALL_HAS_QTWEBENGINE)
			LIST(APPEND VIEW_DEP_LIBRARIES Qt5::WebEngineWidgets Qt5::WebChannel)
		ENDIF()
	ENDIF()
ENDIF()

## On Windows, we might need to explicitly deploy openssl libraries for Qt
IF(WIN32)
	FIND_PATH(QT_SSLEAY_LIB NAME ssleay32.dll PATHS ${QT_BINARY_DIR} NO_DEFAULT_PATH)
	IF(QT_SSLEAY_LIB)
		LIST(APPEND QT_LIBRARIES ${QT_SSLEAY_LIB}/ssleay32.dll)
	ENDIF()

	FIND_PATH(QT_LIBEAY_LIB NAME libeay32.dll PATHS ${QT_BINARY_DIR} NO_DEFAULT_PATH)
	IF(QT_SSLEAY_LIB)
		LIST(APPEND QT_LIBRARIES ${QT_LIBEAY_LIB}/libeay32.dll)
	ENDIF()
ENDIF()

SET(EIGEN3_VERSION_OK "3.0.0")
FIND_PACKAGE(Eigen3 REQUIRED)
INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})

## VIEW dependent packages
IF (BALL_HAS_VIEW)

	## VIEW dependent options
	OPTION(USE_RTFACT "Enable RTfact support" ON)
	OPTION(REQUIRE_RTFACT "Require RTfact support" OFF)

	## OpenGL
	FIND_PACKAGE(OpenGL)
	IF (NOT OPENGL_FOUND OR NOT OPENGL_GLU_FOUND)
		MESSAGE(FATAL_ERROR "Could not find gl/glu!")
	ENDIF()
	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})

	## GLEW
	FIND_PACKAGE(GLEW)
	IF (GLEW_FOUND)
		SET(BALL_HAS_GLEW TRUE)
	ENDIF()

	## RTfact
	IF (USE_RTFACT)
		IF (REQUIRE_RTFACT)
			FIND_PACKAGE(RTfact REQUIRED)
		ELSE()
			FIND_PACKAGE(RTfact)
		ENDIF()

		IF (RTFACT_FOUND)
			## RTfact requires TBB
			IF (NOT CXX_COMPILER_ID STREQUAL "Intel")
				IF (NOT BALL_HAS_TBB)
					MESSAGE(FATAL_ERROR "RTfact support requires TBB!")
				ENDIF()
			ENDIF()

			SET(BALL_HAS_RTFACT TRUE)
			INCLUDE_DIRECTORIES(${RTFACT_INCLUDE_DIR})
		ENDIF()
	ENDIF()

ENDIF(BALL_HAS_VIEW)

## Python
OPTION(BALL_PYTHON_SUPPORT "Compile BALL's python interface (requires python development packages)" ON)

IF (BALL_PYTHON_SUPPORT)
	# make sure that we set the modules that come with contrib
	IF(BALL_CONTRIB_PATH)
		IF(WIN32)
			SET(ENV{PYTHONPATH} "$ENV{PYTHONPATH};${BALL_CONTRIB_PATH}/install/lib/python")
		ELSE()
			SET(ENV{PYTHONPATH} "$ENV{PYTHONPATH}:${BALL_CONTRIB_PATH}/install/lib/python")
		ENDIF()
		SET(BALL_PYTHONPATH $ENV{PYTHONPATH})
	ENDIF()
	FIND_PACKAGE(PythonInterp 2.7)
	IF (PYTHONINTERP_FOUND)
		FIND_PACKAGE(PythonLibs 2.7)
		IF (PYTHONLIBS_FOUND)
			BALL_COMBINE_LIBS(PYTHON_LIBRARIES "${PYTHON_LIBRARIES}" "${PYTHON_DEBUG_LIBRARIES}")
			SET(SIP_EXTRA_OPTIONS "-e")
			FIND_PACKAGE(SIP 4.8)
			SET(BALL_SIP_VERSION ${SIP_VERSION})
			SET(BALL_SIP_VERSION_STR ${SIP_VERSION_STR})
		ENDIF()
	ENDIF()

	IF (NOT PYTHONINTERP_FOUND OR NOT PYTHONLIBS_FOUND OR NOT SIP_FOUND)
		SET(BALL_PYTHON_SUPPORT OFF)
		MESSAGE(STATUS "Disabling python support.")
	ELSE()
		INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
		INCLUDE_DIRECTORIES(${SIP_INCLUDE_DIR})
	ENDIF()
ENDIF()


IF(APPLE)

=== source/EXTENSIONS/CMakeLists.txt ===
PROJECT(BALL_PLUGINS)

OPTION(USE_PRESENTABALL_PLUGIN "Build the PresentaBALL plugin" ON)
OPTION(USE_SPACENAV_PLUGIN "Build the SpaceNavigator input device plugin" ON)
OPTION(USE_VRPN_PLUGIN "Build the VRPN input device plugin" ON)
OPTION(USE_VRPNHD_PLUGIN "Build the VRPNDH input device plugin" ON)
OPTION(USE_JUPYTER_PLUGIN "Build the Jupyter plugin" ON)

IF (USE_PRESENTABALL_PLUGIN)
	ADD_SUBDIRECTORY(PRESENTABALL)
ENDIF()

IF (USE_SPACENAV_PLUGIN)
	ADD_SUBDIRECTORY(SPACENAV)
ENDIF()

IF (USE_VRPN_PLUGIN)
	ADD_SUBDIRECTORY(VRPN)
ENDIF()

IF (USE_VRPNHD_PLUGIN)
	ADD_SUBDIRECTORY(VRPNHD)
ENDIF()

IF (BALL_BUILD_BALLAXY)
	ADD_SUBDIRECTORY(BALLAXY)
ENDIF()

IF (USE_JUPYTER_PLUGIN)
    ADD_SUBDIRECTORY(JUPYTER)
ENDIF()

=== workflow_support/cwl/CMakeLists.txt ===
# The name of the project to build
PROJECT(CWL)

# Check OS and set appropriate Miniconda setup file URL
IF(WIN32)
	SET(MINICONDA_INSTALLER "Miniconda2-latest-Windows-x86_64.exe")
	# what now? SET(LD_LIBRARY_PATH_VAR "DYLD_LIBRARY_PATH")
ELSEIF(APPLE)
	SET(MINICONDA_INSTALLER "Miniconda2-latest-MacOSX-x86_64.sh")
	SET(LD_LIBRARY_PATH_VAR "DYLD_LIBRARY_PATH")
ELSE()
	SET(MINICONDA_INSTALLER "Miniconda2-latest-Linux-x86_64.sh")
	SET(LD_LIBRARY_PATH_VAR "LD_LIBRARY_PATH")
ENDIF()


# Set required output directories
SET(MINICONDA_INSTALL_DIR "${PROJECT_BINARY_DIR}/miniconda")
SET(CTD_OUTFILE_DIR "${PROJECT_BINARY_DIR}/ctd_files")
SET(CWL_STUBS_DIR "${PROJECT_BINARY_DIR}/cwl_stubs")
SET(LOGFILE_DIR "${PROJECT_BINARY_DIR}/log")

# Configure file that will install CTDConverter and its dependencies
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/workflow_support/common/install_ctdconverter.cmake.in" 
               "${PROJECT_BINARY_DIR}/install_ctdconverter.cmake" @ONLY)

# Configure file that will generate all CTDs
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/workflow_support/common/generate_ctds.cmake.in" 
               "${PROJECT_BINARY_DIR}/generate_ctds.cmake" @ONLY)

# Configure CWL build file
CONFIGURE_FILE("${PROJECT_SOURCE_DIR}/cwl_generator.cmake.in" 
               "${PROJECT_BINARY_DIR}/cwl_generator.cmake" @ONLY)

# Add cwl target
ADD_CUSTOM_TARGET(cwl
	COMMAND ${CMAKE_COMMAND} -P "${PROJECT_BINARY_DIR}/cwl_generator.cmake"
	DEPENDS BALLTOOLS
	COMMENT "Generating CWL stubs."
)

=== workflow_support/galaxy/CMakeLists.txt ===
# The name of the project to build
PROJECT(BALLAXY)

# Check OS and set appropriate Miniconda setup file URL
IF(WIN32)
	MESSAGE(STATUS "WARNING: Galaxy is not available for Windows OS. Skipping Ballaxy.")
ELSEIF(APPLE)
	SET(MINICONDA_INSTALLER "Miniconda2-latest-MacOSX-x86_64.sh")
	SET(LD_LIBRARY_PATH_VAR "DYLD_LIBRARY_PATH")
ELSE()
	SET(MINICONDA_INSTALLER "Miniconda2-latest-Linux-x86_64.sh")
	SET(LD_LIBRARY_PATH_VAR "LD_LIBRARY_PATH")
ENDIF()


# Set required output directories
SET(MINICONDA_INSTALL_DIR "${PROJECT_BINARY_DIR}/miniconda")
SET(CTD_OUTFILE_DIR "${PROJECT_BINARY_DIR}/ctd_files")
SET(GALAXY_STUBS_DIR "${PROJECT_BINARY_DIR}/galaxy_stubs")
SET(LOGFILE_DIR "${PROJECT_BINARY_DIR}/log")

# Configure file that will install CTDConverter and its dependencies
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/workflow_support/common/install_ctdconverter.cmake.in" 
               "${PROJECT_BINARY_DIR}/install_ctdconverter.cmake" @ONLY)

# Configure file that will generate all CTDs
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/workflow_support/common/generate_ctds.cmake.in" 
               "${PROJECT_BINARY_DIR}/generate_ctds.cmake" @ONLY)

# Configure Ballaxy build file
CONFIGURE_FILE("${PROJECT_SOURCE_DIR}/ballaxy_generator.cmake.in" 
               "${PROJECT_BINARY_DIR}/ballaxy_generator.cmake" @ONLY)

# Generate Galaxy startup file including necessary ENV variables
IF(${BALLAXY_INSTANCE})
	CONFIGURE_FILE("${PROJECT_SOURCE_DIR}/run_ballaxy.sh.in" "${PROJECT_BINARY_DIR}/run_ballaxy.sh" @ONLY)
ENDIF()

# Add ballaxy target
ADD_CUSTOM_TARGET(ballaxy
	COMMAND ${CMAKE_COMMAND} -P "${PROJECT_BINARY_DIR}/ballaxy_generator.cmake"
	DEPENDS BALLTOOLS
	COMMENT "Building Ballaxy."
)

=== source/APPLICATIONS/BALLVIEW/CMakeLists.txt ===
PROJECT(BALLView)

### list all filenames of the directory here ###
SET(SOURCES_LIST
	demoTutorialDialog.C
	icons.C
	main.C
	mainframe.C
)

### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	demoTutorialDialog.h
	mainframe.h
)

SET(UI_SOURCES_LIST
	aboutDialog.ui
	demoTutorialDialog.ui
)

QT5_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

SET(BALLVIEW_DEP_LIBRARIES BALL VIEW Qt5::Widgets)

IF(APPLE)
	SET(BALLVIEW_EXEC_PROPERTY MACOSX_BUNDLE)
	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
	SET(RESOURCES_LIST ${PROJECT_SOURCE_DIR}/BALLView.icns ${CMAKE_SOURCE_DIR}/LICENSE)
	SET_SOURCE_FILES_PROPERTIES(${RESOURCES_LIST} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ELSEIF(WIN32)
	SET(BALLVIEW_EXEC_PROPERTY WIN32)
	SET(RESOURCES_LIST BALLView.rc)
ELSEIF(UNIX)
	LIST(APPEND BALLVIEW_DEP_LIBRARIES "pthread" "X11")
ENDIF()

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})
ADD_DEFINITIONS(${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS})

ADD_EXECUTABLE(BALLView
	${BALLVIEW_EXEC_PROPERTY}
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${UIC_OUTFILES}
	${RESOURCES_LIST}
)

TARGET_LINK_LIBRARIES(BALLView ${BALLVIEW_DEP_LIBRARIES})

#Setup the translations
INCLUDE(BALLViewTranslations)

IF(APPLE)
	IF(QT_DEPLOY_EXECUTABLE)
		CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/BALLViewInstallFix.cmake.in ${PROJECT_BINARY_DIR}/BALLViewInstallFix.cmake @ONLY)
		INSTALL(SCRIPT ${PROJECT_BINARY_DIR}/BALLViewInstallFix.cmake)
	ENDIF()
ELSE()
	INSTALL(TARGETS BALLView
		COMPONENT "${COMPONENT_BALLVIEW}"
		RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
		BUNDLE DESTINATION "${BALL_BUNDLE_INSTALL_DIRECTORY}"
	)

	IF(WIN32)
		IF(QT_DEPLOY_EXECUTABLE)
			INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${QT_DEPLOY_EXECUTABLE} \$\{CMAKE_INSTALL_PREFIX\}/${CMAKE_INSTALL_BINDIR}/BALLView.exe)"
				COMPONENT "${COMPONENT_BALLVIEW}")
		ENDIF()
	ENDIF()
ENDIF()

=== source/APPLICATIONS/MMFF94/CMakeLists.txt ===
# The name of the project to build
PROJECT(MMFF94)

# Set BALL specific includes and compilerflags
ADD_DEFINITIONS(${BALL_ADD_CXXFLAGS})

# add MMFF94 targets
SET(MMFF94_EXECUTABLES
        compareForces
        readMMFF94TestFile
        splitMMFFTestSuiteMolFiles
        splitMMFFTestSuiteOptiFiles
        testKekulizer
)

FOREACH(i ${MMFF94_EXECUTABLES})
        ADD_EXECUTABLE(${i} ${i}.C)
        TARGET_LINK_LIBRARIES(${i} BALL Qt5::Core)
        SET_PROPERTY(TARGET ${i} PROPERTY FOLDER UTILITIES)
        SET_TARGET_PROPERTIES(${i} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/MMFF94")
ENDFOREACH(i)

### add filenames to Visual Studio solution
SET(MMFF94_SOURCES)
FOREACH(i ${MMFF94_EXECUTABLES})
	LIST(APPEND MMFF94_SOURCES "${i}")
ENDFOREACH(i)
SOURCE_GROUP("" FILES ${MMFF94_SOURCES})

=== source/APPLICATIONS/TOOLS/CMakeLists.txt ===
# The name of the project to build
PROJECT(TOOLS)

# Set BALL specific includes and compilerflags
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})
ADD_DEFINITIONS(${BALL_ADD_CXXFLAGS})

###### add TOOLS targets ########
SET(TOOLS_EXECUTABLES)
INCLUDE(sources.cmake)

FOREACH(i ${TOOLS_EXECUTABLES})
	ADD_EXECUTABLE(${i} ${i}.C)
	TARGET_LINK_LIBRARIES(${i} BALL Qt5::Core)
	SET_PROPERTY(TARGET ${i} PROPERTY FOLDER TOOLS)
	SET_TARGET_PROPERTIES(${i} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${TOOLS_RUNTIME_OUTPUT_DIRECTORY})
ENDFOREACH()


ADD_CUSTOM_TARGET(BALLTOOLS)
ADD_DEPENDENCIES(BALLTOOLS ${TOOLS_EXECUTABLES})

=== source/APPLICATIONS/UTILITIES/CMakeLists.txt ===
# The name of the project to build
PROJECT(UTILITIES)

# Set BALL specific includes and compilerflags
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})
ADD_DEFINITIONS(${BALL_ADD_CXXFLAGS})

# add UTILITIES targets
SET(UTILITIES_EXECUTABLES)
INCLUDE(sources.cmake)

FOREACH(i ${UTILITIES_EXECUTABLES})
        ADD_EXECUTABLE(${i} ${i}.C)
        TARGET_LINK_LIBRARIES(${i} BALL Qt5::Core)
        SET_PROPERTY(TARGET ${i} PROPERTY FOLDER UTILITIES)
	SET_TARGET_PROPERTIES(${i} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${UTILS_RUNTIME_OUTPUT_DIRECTORY})
ENDFOREACH(i)

=== source/EXTENSIONS/VRPN/CMakeLists.txt ===
PROJECT(VRPN)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the VRPN plugin.")
	RETURN()
ENDIF()

FIND_PACKAGE(VRPN)

## VRPN
IF(NOT VRPN_FOUND)
	MESSAGE(STATUS "Could not find VRPN libraries. Disabling the VRPN plugin")
	RETURN()
ENDIF()

INCLUDE_DIRECTORIES(${VRPN_INCLUDE_DIR})

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(SOURCES_LIST
	${DIRECTORY}/VRPNPlugin.C
	${DIRECTORY}/VRPNDriver.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/VRPNPlugin.h
)

QT5_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT5_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT5_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginVRPN SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginVRPN PROPERTIES PREFIX "")

INSTALL(TARGETS pluginVRPN
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginVRPN BALL VIEW ${VRPN_LIBRARY} Qt5::Core)

=== source/EXTENSIONS/VRPNHD/CMakeLists.txt ===
PROJECT(VRPNHD)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the VRPNHD plugin.")
	RETURN()
ENDIF()

FIND_PACKAGE(VRPN)

## VRPN
IF(NOT VRPN_FOUND)
	MESSAGE(STATUS "Could not find VRPN libraries. Disabling the VRPNHD plugin")
	RETURN()
ENDIF()

INCLUDE_DIRECTORIES(${VRPN_INCLUDE_DIR})

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(SOURCES_LIST
	${DIRECTORY}/VRPNHDPlugin.C
	${DIRECTORY}/VRPNHDDriver.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/VRPNHDPlugin.h
)

QT5_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT5_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT5_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginVRPNHD SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginVRPNHD PROPERTIES PREFIX "")

INSTALL(TARGETS pluginVRPNHD
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginVRPNHD BALL VIEW ${VRPN_LIBRARY} Qt5::Core)

=== source/PYTHON/EXTENSIONS/CMakeLists.txt ===
PROJECT(BALLPython)

IF(BALL_PYTHON_SUPPORT)
	INCLUDE(SIPMacros)

	REMOVE_DEFINITIONS(-pedantic)

	INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})

	SET(SIP_EXTRA_OPTIONS "-e")

	FILE(GLOB BALL_SIP_DEPENDS "BALL/*.sip")
	FILE(GLOB VIEW_SIP_DEPENDS "VIEW/*.sip")

	SET(SIP_EXTRA_FILES_DEPEND ${BALL_SIP_DEPENDS} ${VIEW_SIP_DEPENDS})

	# Add the BALLCore python bindings
	SET(SIP_EXTRA_SOURCES 
		BALL/pyBALLSipHelper.C
		BALL/pyIndexList.C
		BALL/pyConstant.C
	)
        ADD_SIP_PYTHON_MODULE(BALLCore BALLCoremodule BALL/BALLCore.sip BALL Qt5::Core)
	
	IF(BALL_HAS_VIEW)
		SET(SIP_EXTRA_SOURCES
			VIEW/pyCompositeList.C
			VIEW/pyBALLSipHelper.C
			VIEW/pyColorRGBAVector.C
			VIEW/pyDatasetVector.C
		)
		# Add the VIEW python bindings
		SET(SIP_INCLUDES ${PROJECT_SOURCE_DIR})
                ADD_SIP_PYTHON_MODULE(VIEW VIEWmodule VIEW/VIEW.sip BALL VIEW Qt5::Widgets)
	ENDIF()

	# Install the BALL.py script
	IF(NOT WIN32)
		SET(BALL_PY_LOCATION ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
	ELSE()
		SET(BALL_PY_LOCATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR})

	ENDIF()

	ADD_CUSTOM_COMMAND(TARGET BALLCoremodule POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/BALL.py ${BALL_PY_LOCATION}
	)

	IF(NOT APPLE)
		INSTALL(TARGETS BALLCoremodule
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		)

		IF(BALL_HAS_VIEW)
			INSTALL(TARGETS VIEWmodule
				COMPONENT "${COMPONENT_PYTHON_BINDINGS_VIEW}"
				RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
				LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			)
		ENDIF()

		INSTALL(FILES ${PROJECT_SOURCE_DIR}/BALL.py
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			DESTINATION "${BALL_PYTHON_INSTALL_DIRECTORY}"
		)

		IF (WIN32)
			#		INSTALL(FILES ${PYTHON_EXECUTABLE}
			#	COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			#	DESTINATION "${CMAKE_INSTALL_BINDIR}"
			#)


			GET_FILENAME_COMPONENT(PYTHON_SITE_PACKAGES_DIR ${PYTHON_EXECUTABLE} PATH)
			SET(PYTHON_SITE_PACKAGES_DIR "${PYTHON_SITE_PACKAGES_DIR}/lib")

			INSTALL(DIRECTORY "${PYTHON_SITE_PACKAGES_DIR}"
				COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
				DESTINATION "${CMAKE_INSTALL_BINDIR}"
			)
		ENDIF ()
	ENDIF()

ENDIF()

=== debian/changelog ===
ball (1.5.0+git20180813.37fc53c-6) unstable; urgency=medium

  [ Steffen Möller ]
  * Update metadata - yamllint, BALL paper

  [ Stuart Prescott ]
  * Add missing Breaks/Replaces for python3-ball
    Closes: #953358

  [ Andreas Tille ]
  * Add debian/salsa-ci.yml

 -- Andreas Tille <tille@debian.org>  Mon, 09 Mar 2020 11:45:03 +0100

ball (1.5.0+git20180813.37fc53c-5) experimental; urgency=medium

  * Team upload.
  * Stop using Python 2 to build, make a Python 3 module instead
    (Closes: #936183).

 -- Stuart Prescott <stuart@debian.org>  Sun, 01 Mar 2020 15:22:57 +1100

ball (1.5.0+git20180813.37fc53c-4) unstable; urgency=medium

  * Team upload (Closes: #948438)
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 12 (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Remove obsolete fields Name, Contact from debian/upstream/metadata.
  * Add Mult-Arch hints
  * build-dep on python2-dev, not the soon to be removed python-dev

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 19 Feb 2020 15:20:40 +0100

ball (1.5.0+git20180813.37fc53c-3) unstable; urgency=medium

  * Add missing Breaks+Replaces: libballview1.4-dev
    Closes: #919225
  * Enable building with dpkg-buildpackage -A
    Closes: #919239

 -- Andreas Tille <tille@debian.org>  Mon, 14 Jan 2019 08:12:12 +0100

ball (1.5.0+git20180813.37fc53c-2) unstable; urgency=medium

  * Fix Build-Depends (Thanks for the hints to Adrian Bunk
    <bunk@debian.org>)
    Closes: #784451
  * Fix FTBFS on architectures where char is unsigned
    (Thanks for the fix to Adrian Bunk <bunk@debian.org>)
    Closes: #919172

 -- Andreas Tille <tille@debian.org>  Sun, 13 Jan 2019 15:49:01 +0100

ball (1.5.0+git20180813.37fc53c-1) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.
  * Trim trailing whitespace.

  [ Andreas Tille ]
  * New upstream version
    Closes: #784451, #905443, #911881
  * Use Git mode in watch file
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * Switch to Qt5
    Closes: #874837
  * Drop python-ballview package
  * Do not fail in case of build time test failures
  * d/control: Remove X-Python-Version field
  * d/rules: Remove manual CFLAGS settings
  * d/rules: Remove cruft from python-ball package
  * Use wrapper to export BALL_DATA_PATH

 -- Andreas Tille <tille@debian.org>  Thu, 10 Jan 2019 20:52:01 +0100

ball (1.4.3~beta1-4) unstable; urgency=medium

  * FTBFS with sip 4.19.x (Thanks for the hint to upsteam solution given
    by Dmitry Shachnev <mitya57@debian.org>)
    Closes: #867660
  * debhelper 10
  * Standards-Version: 4.1.0 (no changes needed)
  * Add dh_sip after dh_install (Thanks for the hint to Dmitry Shachnev
    <mitya57@debian.org>)
  * Do not run test suite parallel
  * Drop test that leads frequently to unpredictable failures
  * Desperately remove all tests that tend to fail randomly

 -- Andreas Tille <tille@debian.org>  Thu, 21 Sep 2017 14:44:17 +0200

=== debian/control ===
Source: ball
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Steffen Moeller <moeller@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-python,
               qtbase5-dev,
               qttools5-dev,
               libqt5opengl5-dev,
               python3-sip-dev,
               flex,
               bison,
               cmake,
               qtwebengine5-dev [amd64 arm64 armhf i386 mipsel],
               libfftw3-dev,
               libeigen3-dev,
               libgsl0-dev,
               python3-dev,
               libxrender-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-thread-dev,
               libboost-math-dev,
               libboost-system-dev,
               libasio-dev,
               libboost-regex-dev,
               libxmu-dev,
               libglew-dev,
               libx11-dev,
               tidy,
               chrpath
Build-Depends-Indep: doxygen,
                     graphviz,
                     ghostscript,
                     texlive-latex-base,
                     texlive-latex-recommended,
                     texlive-fonts-recommended,
                     texlive-latex-extra
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/ball
Vcs-Git: https://salsa.debian.org/med-team/ball.git
Homepage: http://www.ball-project.org/

Package: libball1.5-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Biochemical Algorithms Library (data files)
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 It provides an extensive set of data structures as well as classes
 for Molecular Mechanics, advanced solvation methods, comparison and
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland
 University, Saarbruecken, Germany).
 .
 This package contains the data files (force field parameters, fragment
 data bases, etc) necessary for using BALL.

Package: libball1.5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libball1.5-data
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 It provides an extensive set of data structures as well as classes
 for Molecular Mechanics, advanced solvation methods, comparison and
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland
 University, Saarbruecken, Germany).
 .
 This package contains the view - independent parts of BALL (libBALL,
 data directories et al., except for libVIEW) and can be installed on
 machines without X11.

Package: libball1.5-dev
Architecture: any
Section: libdevel
Depends: libball1.5 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libball1.5-doc
Breaks: libball1.3-dev,
        libball1.4-dev
Replaces: libball1.4-dev
Description: Header files for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 It provides an extensive set of data structures as well as classes
 for Molecular Mechanics, advanced solvation methods, comparison and
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland
 University, Saarbruecken, Germany).
 .
 This package comprises the header files allowing to create
 one's own applications with the BALL library.

Package: libballview1.5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Biochemical Algorithms Library, VIEW framework
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 It provides an extensive set of data structures as well as classes
 for Molecular Mechanics, advanced solvation methods, comparison and
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland
 University, Saarbruecken, Germany).
 .
 This package contains the view parts of BALL (libVIEW). Those are
 required for molecular visualization and for running BALLView.

Package: libballview1.5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libballview1.5 (= ${binary:Version}),
         ${misc:Depends}
Recommends: libball1.5-doc
Breaks: libballview1.3-dev,
        libballview1.4-dev
Replaces: libballview1.4-dev
Description: Header files for the VIEW part of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 This package comprises the header files allowing to create one's own
 applications with the VIEW framework of the BALL library.

Package: python3-ball
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${sip:Depends},
         libball1.5,
         ${misc:Depends}
Breaks: python-ball
Replaces: python-ball
Description: Python bindings for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 This package provides scripting access to the VIEW-independent functionality
 of the Biochemical Algorithms Library (BALL).

Package: ballview
Architecture: any
Depends: ${shlibs:Depends},
         libball1.5,
         libballview1.5,
         python3-ball,
         ${misc:Depends}
Description: free molecular modeling and molecular graphics tool
 BALLView provides fast OpenGL-based visualization of molecular structures,
 molecular mechanics methods (minimization, MD simulation using the
 AMBER, CHARMM, and MMFF94 force fields), calculation and visualization
 of electrostatic properties (FDPB) and molecular editing features.
 .
 BALLView can be considered a graphical user interface on the basis of
 BALL (Biochemical Algorithms Library) with a focus on the most common
 demands of protein chemists and biophysicists in particular.  It is
 developed in the groups of Hans-Peter Lenhof (Saarland University,
 Saarbruecken, Germany) and Oliver Kohlbacher (University of Tuebingen,
 Germany). BALL is an application framework in C++ that has been
 specifically designed for rapid software development in Molecular
 Modeling and Computational Molecular Biology.  It provides an extensive
 set of data structures as well as classes for Molecular Mechanics,
 advanced solvation methods, comparison and analysis of protein
 structures, file import/export, and visualization.

Package: libball1.5-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Suggests: libball1.5
Conflicts: libball1.3-doc,
           libball1.4-doc
Description: documentation for the BALL library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

SOVERSION=1.5
BALL_INSTALL_PATH=build
PYTHON_VERSION=$(shell py3versions -d)
PYTHON_SITE_PATH=/lib/python3/dist-packages

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --builddirectory=build --with python3

override_dh_auto_configure:
	mkdir -p build
	cd build && LDFLAGS="$(LDFLAGS)" CXXFLAGS="$(CXXFLAGS)" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
	            cmake .. -DCMAKE_SOURCE_DIR=$(CURDIR) -DCMAKE_INSTALL_PREFIX=./usr \
		    -DBALL_PATH=/usr -DBALL_DATA_PATH=/usr/share/BALL-$(SOVERSION)/data \
		    -DCMAKE_VERBOSE_MAKEFILE=ON

# Set BALL_DATA_PATH so that test scripts find it
export BALL_DATA_PATH=$(CURDIR)/data
# Make sure HOME exists (for Directory_test)
export HOME=/tmp

# The testsuite issues several failures
# Run it, but ignore the return code for now.
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel -- || true
endif

# Different tests are failing in different runs

#The following tests FAILED:
#         86 - Composite_test4 (Failed)
#         87 - Composite_test5 (Failed)
#Errors while running CTest

#The following tests FAILED:
#        112 - Fragment_test (Failed)
#        113 - Chain_test (Failed)
#Errors while running CTest


override_dh_auto_build-arch:
	## Fix upstream issue of missing UI files
#	uic-qt4 source/VIEW/DIALOGS/assignBondOrderConfigurationDialog.ui > include/BALL/VIEW/UIC/ui_assignBondOrderConfigurationDialog.h
#	uic-qt4 source/VIEW/DIALOGS/assignBondOrderResultsDialog.ui       > include/BALL/VIEW/UIC/ui_assignBondOrderResultsDialog.h
#	uic-qt4 source/VIEW/DIALOGS/atomOverview.ui                       > include/BALL/VIEW/UIC/ui_atomOverview.h
	## ...
	## Uhmmm, seems we need to do this for all UI files mentioned in
	##   source/VIEW/DIALOGS/sources.cmake
	## but I really hope some cmake expert might be able to find a clue
	## how to trigger cmake to do it as intended by upstream.
	## Somehow the code
	##   ADD_BALL_UIFILES("VIEW/DIALOGS" "${UI_LIST}")
	## needs to be called before the build code below can be started
	make -C build BALL VIEW BALLView build_tests install

override_dh_auto_build-indep:
	make -C build doc doc_tutorial install

override_dh_auto_clean:
	[ -d source ] && cd source ; \
	if [ -f Makefile ] ; \
	then  \
		make clean ; \
		cd PYTHON/EXTENSIONS; \
		make clean; \
		rm -rf ../lib/Linux*; \
		rm -rf ../doc/doxygen/latex/*; \
		rm -f $(CURDIR)/source/config.status 2>/dev/null; \
	fi
	rm -f data/BALLView/translations/BALLView.de_DE.qm
	rm -f data/BALLView/translations/BALLView.zh_TW.qm
	rm -f doc/TUTORIAL/*.aux
	rm -rf $(BALL_INSTALL_PATH)
	find . -name "*.o" | xargs -r rm
	find . -type l | xargs -r rm
	find doc/TUTORIAL/ -name "tutorial.*" | egrep -v ".(tex|bib)$$" |xargs -r rm
	rm -f include/BALL/BALL.doc
	# find . -name "*.doc" -delete
	# Remove self-create UI header file
	rm -f include/BALL/VIEW/UIC/ui_assignBondOrderConfigurationDialog.h \
	      include/BALL/VIEW/UIC/ui_assignBondOrderResultsDialog.h \
	      include/BALL/VIEW/UIC/ui_atomOverview.h


override_dh_auto_install-arch:
	mkdir -p debian/libball$(SOVERSION)/usr/lib \
		debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION) \
		debian/libballview$(SOVERSION)/usr/lib \
		debian/python3-ball/usr/share/BALL-$(SOVERSION) \
		debian/python3-ball/usr/$(PYTHON_SITE_PATH) \
                debian/ballview/usr/lib/ballview/

	mkdir -p debian/ballview/usr/share/BALL-$(SOVERSION)/data/graphics

	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/BALLView/*	debian/ballview/usr/share/doc/ballview/
	cp    $(BALL_INSTALL_PATH)/usr/bin/BALLView		debian/ballview/usr/lib/ballview/
	cp -a debian/bin/*					debian/ballview/usr/bin

	find $(BALL_INSTALL_PATH)/usr/lib/ -name libBALL*.so.* | xargs -r cp --target-directory debian/libball$(SOVERSION)/usr/lib/
	find $(BALL_INSTALL_PATH)/usr/lib/ -name libVIEW*.so.* | xargs -r cp --target-directory debian/libballview$(SOVERSION)/usr/lib/

	# debian needs the logo in the ballview - package, not in the libball
	cp $(BALL_INSTALL_PATH)/usr/share/BALL/graphics/ballview*.xpm debian/ballview/usr/share/pixmaps/

	cp -r $(BALL_INSTALL_PATH)/usr/share/doc/BALL/EXAMPLES/PYTHON	debian/python3-ball/usr/share/BALL-$(SOVERSION)
	cp -a source/PYTHON/EXTENSIONS/*       debian/python3-ball/usr/$(PYTHON_SITE_PATH)
#	cp $(BALL_INSTALL_PATH)/usr/lib/BALLCore.so   debian/python-ball/usr/$(PYTHON_SITE_PATH)

	# -dev packages are arch dependent
	mkdir -p debian/libball$(SOVERSION)-dev/usr/lib \
		debian/libballview$(SOVERSION)-dev/usr/include/BALL \
		debian/libballview$(SOVERSION)-dev/usr/lib \
		debian/libball$(SOVERSION)-dev/usr/include
	# move the cmake configuration files to their final location
	cp -R $(BALL_INSTALL_PATH)/usr/lib/cmake/ debian/libball$(SOVERSION)-dev/usr/lib

	cp -r $(BALL_INSTALL_PATH)/usr/include/BALL       debian/libball$(SOVERSION)-dev/usr/include
	cp -r $(BALL_INSTALL_PATH)/usr/include/BALL/VIEW  debian/libballview$(SOVERSION)-dev/usr/include/BALL

	# get rid of the VIEW includes in libball-dev
	rm -rf debian/libball$(SOVERSION)-dev/usr/include/BALL/VIEW

	# eliminating chrpath settings
	chmod 755 debian/ballview/usr/lib/ballview/BALLView
	chrpath -d debian/ballview/usr/lib/ballview/BALLView
	find debian -name "*.so" | xargs -r chrpath -d

override_dh_auto_install-indep:
	mkdir -p debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html \
		debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc \
		debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html/BALL

	cp    $(BALL_INSTALL_PATH)/usr/share/doc/BALL/TUTORIAL/tutorial.pdf	debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/
#	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/classes			debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
#	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/internal			debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	# we need the BALLView documentation in the data path as well... sorry for that
	cp -r $(BALL_INSTALL_PATH)/usr/share/doc/BALL/EXAMPLES/PYTHON/BALLView	debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	cp -r $(BALL_INSTALL_PATH)/usr/share/doc/BALL/html/*			debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html/BALL

	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/*    debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)

override_dh_installdocs:
	dh_installdocs
	find debian/*/usr/share -type d -empty -delete
	find debian/*/usr/share -name jquery.js -delete
	find debian/*/usr/share -name license.txt -delete

override_dh_install:
	dh_install
	dh_sip3
	if [ -d debian/python3-ball ] ; then \
	    find debian/python3-ball/usr/lib/python*/dist-packages/ -name BALLPyMacros.h -delete ; \
	    find debian/python3-ball -name CMakeLists.txt -delete ; \
	fi

=== debian/watch ===
version=4

opts="mode=git,pretty=1.5.0+git%cd.%h" \
    https://github.com/BALL-Project/ball.git HEAD

# Issue asking for release tags:
#   https://github.com/BALL-Project/ball/issues/655
# once this is fixed the old watch file can be brought into effect again:
#
# opts="uversionmangle=s/_/./g;s/-BETA/~beta/" \
#  https://github.com/BALL-Project/ball/releases .*/archive/V?(\d[-\d._BETA]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
